/*----------------------------------------------------------------------+
|
|   C Library includes
|
+----------------------------------------------------------------------*/
#include <mdl.h>
#include <stdio.h>
#include <string.h>
#include <toolsubs.h>
#include <dlmsys.fdf>
#include <stdlib.h>
#include <assert.h>

/*----------------------------------------------------------------------+
|
|   MicroStation MDL includes
|
+----------------------------------------------------------------------*/
#include <dlogitem.h>
#include <dlogids.h>
#include <cmdlist.h>
#include <dlmsys.fdf>
#include <cexpr.h>
#include <mstxtfil.h>
#include <mselems.h>
#include <msstrlst.h>
#include <msstrngl.h>
#include <colrname.h>
#include <elementref.h>
#include <tcb.h>
#include <toolsubs.h>
#include <msnativewindow.h>

#include <mselemen.fdf>
#include <mselmdsc.fdf>
#include <mscexpr.fdf>
#include <msrsrc.fdf>
#include <mssystem.fdf>
#include <msdialog.fdf>
#include <ditemlib.fdf>
#include <msdb.fdf>
#include <msoutput.fdf>
#include <mscnv.fdf>
#include <mslocate.fdf>
#include <msstate.fdf>
#include <msmisc.fdf>
#include <mscell.fdf>
#include <leveltable.fdf>
#include <msfile.fdf>
#include <listmodel.fdf>
#include <mscurrtr.fdf>
#include <mswindow.fdf>
#include <msscancrit.fdf>
#include <msmodel.fdf>
#include <mscntr.fdf>
#include <msinput.fdf>
#include <msraster.fdf>
#include <mslinkge.fdf>
#include <msview.fdf>
#include <msselect.fdf>


#include <xfmApi.fdf>
#include <xfmFeatureMgr.fdf>
#include <xfmLinearOp.fdf>
#include <xfmCompCurveOp.fdf>
#include <xfmMethodDef.fdf>
#include <xfmOperationDef.fdf>
#include <xfmSettings.fdf>
#include <xfmInitialValueDef.fdf>
#include <xfmInputValue.fdf>
#include <xfmCompCurveParams.fdf>

BEGIN_EXTERN_C

extern Tcb *tcb;
Private RscFileHandle m_rFileH = (RscFileHandle) NULL;

void createGasMainFeatureDef(void)
    {
    BoolInt        useDefaultFormView = FALSE;
    StatusInt      status;
    XfmFeatureDefP featureDef = NULL;
    XfmFeatureDefP propertyDef = NULL;
    XfmSettingsP settings = NULL;
    XfmInitialValueDefP initialValueDef = NULL;
    XfmMethodGroupDefP methodGroup = NULL;
    XfmMethodDefP method = NULL;
    XfmOperationDefP operation = NULL;

    // Initialize "GasMain" root feature definition
    xfmFeatureDef_new(&featureDef);
    xfmFeatureDef_setName(featureDef, L"GM");
    xfmFeatureDef_setDescription(featureDef, L"Gas Main linear feature");
    xfmFeatureDef_setDisplayName(featureDef, L"Gas Main display name");
    xfmFeatureDef_setCategoryName(featureDef, L"Gas");
    xfmFeatureDef_setGisTypeName(featureDef, XFM_GISTYPENAME_LINEAR);
    xfmFeatureDef_setIsGeometryCollection(featureDef, FALSE);
    xfmFeatureDef_setGisTypeId(featureDef, XFMFEATUREGISTYPE_LineStringOrCurve);
    xfmFeatureDef_setMinOccurrences(featureDef, 1);
    xfmFeatureDef_setMaxOccurrences(featureDef, 1);

    // Add XfmPropertyDef's to root feature definition
    xfmFeatureDef_addProperty(&propertyDef, featureDef, L"ID", XFM_DATATYPE_STRING, 32);
    xfmPropertyDef_setDisplayName(propertyDef, L"Gas Main ID");
    xfmPropertyDef_setIsReadOnlyProperty(propertyDef, FALSE);
    xfmPropertyDef_setIsExternalProperty(propertyDef, FALSE);
    xfmPropertyDef_setLoadType(propertyDef, XFMPROPERTY_LOADTYPEID_Dgn);
    xfmPropertyDef_setPreferenceType(propertyDef, XFMPROPERTYPREFERENCETYPE_DesignFile);
    xfmPropertyDef_setFormatToDisplayTypeId(propertyDef, XFMFORMATVALUETYPE_String);
    xfmPropertyDef_setFormatToInternalTypeId(propertyDef, XFMFORMATVALUETYPE_String);
    xfmPropertyDef_free(&propertyDef);

    xfmFeatureDef_addProperty(&propertyDef, featureDef, L"Size", XFM_DATATYPE_INT, 25);
    xfmPropertyDef_setDisplayName(propertyDef, L"Gas Main size");
    xfmPropertyDef_setIsReadOnlyProperty(propertyDef, FALSE);
    xfmPropertyDef_setIsExternalProperty(propertyDef, FALSE);
    xfmPropertyDef_setLoadType(propertyDef, XFMPROPERTY_LOADTYPEID_Dgn);
    xfmPropertyDef_setPreferenceType(propertyDef, XFMPROPERTYPREFERENCETYPE_Session);
    xfmPropertyDef_setFormatToDisplayTypeId(propertyDef, XFMFORMATVALUETYPE_Integer);
    xfmPropertyDef_setFormatToInternalTypeId(propertyDef, XFMFORMATVALUETYPE_Integer);
    xfmInitialValueDef_create(&initialValueDef, XFMINITIALVALUEKEY_TYPEID_Placing, XFMINPUTVALUETYPE_Value, L"2");
    xfmInitialValueDef_setSynchPreference(initialValueDef, TRUE);
    xfmFeatureDef_addPropertyInitialValueRule(featureDef, propertyDef, XFM_INITIALVALUEKEY_Placing, initialValueDef);
    xfmInitialValueDef_free(&initialValueDef);
    xfmPropertyDef_free(&propertyDef);

    // create XfmSettings for root feature definition
    xfmSettings_create(&settings, XFMSETTINGS_TYPE_UNKNOWN /*XFMSETTINGS_TYPE_LINEAR*/);
    xfmFeatureDef_setSettings(featureDef, settings);
    xfmSettings_free(&settings);

    xfmFeatureDef_addGeometricProperties(featureDef);

     // Specify that this feature definition remains in the session list of FeatureDefs after feature instances of this definition are removed from the session
    xfmFeatureDef_setKeepInSession(featureDef, TRUE);

    // Add new feature definition to the session list of FeatureDefs so it is available for consumers
    status = xfmFeatureDefMgr_addRootFeatureDefToList(featureDef);

    // Add default command metadata including default Place & Edit methods with tool settings and dialog definitions.
    // I mainly want default Edit method plus the tool settings & dialog definitions created for me(but I could also create these myself).
    // Placement tool settings for a linear feature will contain CompCurve placement options. And my "PlaceGasMain" MDL operation will use a XfmCompCurveOpP.
    xfmFeatureDef_addDefaultCommandMetadata(featureDef);

    xfmFeatureDef_free(&featureDef);

    xfmDialogMgr_refreshCommandManager();
    }

int createXfmFeatureInstance(MSElementDescrP edP, char* objCode)
    {
    StatusInt   status;
    MSWChar fcode[20];
    XfmFeatureDefP featureDef = NULL;
    XfmPropertyDefP propertyDef = NULL;
    XfmFeatureP  feature = NULL;

    mdlCnv_convertMultibyteToUnicode(objCode, -1, fcode, 20);
    xfmFeatureDef_create(&featureDef, fcode);

    status = xfmFeature_create(&feature, fcode, NULL);
    if (SUCCESS != status)
        return status;

    xfmFeature_initializeProperties(feature, L"placing");

    xfmFeatureDef_getPropertyDefByName(featureDef, &propertyDef, L"ID");
    xfmFeature_setPropertyByPropertyDef(feature, propertyDef, L"123abc", TRUE, TRUE, FALSE);
    xfmFeatureDef_getPropertyDefByName(featureDef, &propertyDef, L"Size");
    xfmFeature_setPropertyByPropertyDef(feature, propertyDef, L"25", TRUE, TRUE, FALSE);

    status = xfmFeature_setGeometry(feature, edP);
    if (SUCCESS != status)
        {
        printf("xfmFeature_setGeometry err:%d\n", status);
        return status;
        }

    status = xfmFeature_write(feature, FALSE);
    if (SUCCESS != status)
        {
        printf("xfmFeature_write err:%d\n", status);
        return status;
        }

    status = xfmFeature_applyAttributeChanges(feature);
    if (SUCCESS != status)
        return status;

    xfmFeature_applySchemaChanges(feature);
    xfmFeature_savePreferenceProperties(feature, XFM_INITIALVALUEKEY_Placing);

    status = xfmFeature_write(feature, FALSE);
    if (SUCCESS != status)
        {
        printf("xfmFeature_write err:%d\n", status);
        return status;
        }

    xfmFeature_free(&feature);

    return SUCCESS;
    }

void testXfm()
    {
    DPoint3d pts[2];
    MSElementDescrP edP;
    MSElement el;

    pts[0].x = 0; pts[0].y = 0; pts[0].z = 0;
    pts[1].x = 10; pts[1].y = 10; pts[1].z = 0;

    mdlLine_create(&el, NULL, pts);
    mdlElmdscr_new(&edP, NULL, &el);

    createXfmFeatureInstance(edP, "GM");
    }

/*---------------------------------------------------------------------------------**//**
| Function called when XFM is ready.
+---------------+---------------+---------------+---------------+---------------+------*/
void XfmReady()
    {
    createGasMainFeatureDef();
    }

/*---------------------------------------------------------------------------------**//**
| Function called during new file open/change events.
+---------------+---------------+---------------+---------------+---------------+------*/
void myOpenMasterFileStartHook
(
void*   pData
)
    {
    if (xfmSystem_isSystemReady())
        {
        // If XFM core API services are ready, continue with your XFM dependent code.        
        XfmReady();
        }
    else
        {
        // If XFM core API services are not ready, setup callback and wait for notification.
        xfmSystem_setFunction (XFMSYSTEM_READY, XfmReady);
        }
    }

/*---------------------------------------------------------------------------------**//**
| Function called during new file open/change events to extend session feature classes.
+---------------+---------------+---------------+---------------+---------------+------*/
void myUnloadHook
(
int unloadType
)
    {
    xfmSystem_unSetFunction (XFMSYSTEM_OPEN_MASTERFILE_START, myOpenMasterFileStartHook);
    }

/*-------------------------------------------------------------------------------------*/
/*-------------------------------------- M A I N --------------------------------------*/
/*-------------------------------------------------------------------------------------*/
DLLEXPORT int MdlMain(int argc, char *argv[])
    {
    mdlResource_openFile (&m_rFileH, NULL, 0);

    xfmSystem_setFunction (XFMSYSTEM_OPEN_MASTERFILE_START, myOpenMasterFileStartHook);
    mdlSystem_setFunction (SYSTEM_UNLOAD_PROGRAM, myUnloadHook);

    //testXfm();

    return SUCCESS;
    }

END_EXTERN_C
